unit MainForm;

{
Copyright: Algorithm (c) E. W. Bachtal, Inc

Permission is hereby granted, free of charge, to any person obtaining a copy of this software
and associated documentation files (the "Software"), to deal in the Software without restriction,
including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense,
and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so,
subject to the following conditions:

  The above copyright notice and this permission notice shall be included in all copies or substantial
  portions of the Software.

The software is provided "as is", without warranty of any kind, express or implied, including but not
limited to the warranties of merchantability, fitness for a particular purpose and noninfringement. In
no event shall the authors or copyright holders be liable for any claim, damages or other liability,
whether in an action of contract, tort or otherwise, arising from, out of or in connection with the
software or the use or other dealings in the software.

This is a Delphi XE port of ewbi's Excel formula parser.  ( hadv.de )

Original Javascript post is: http://ewbi.blogs.com/develops/2004/12/excel_formula_p.html

Other ports are:
  C#:      http://ewbi.blogs.com/develops/2007/03/excel_formula_p.html
  Python:  http://www.ewbi.com/ewbi.develop/samples/jsport_nonEAT.html
  C++:     https://github.com/lishen2/Excel_formula_parser_cpp

Versions:
  1.0:    2011/06/13 - Orginal Delphi XE port by hadv.de
}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, ExtCtrls, Grids;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    btnParse: TButton;
    txfExcelFormula: TEdit;
    Label1: TLabel;
    m_sGridParse: TStringGrid;
    Label2: TLabel;
    procedure btnParseClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

uses ExcelFormulaToken, ExcelFormula;

{$R *.dfm}


procedure TForm1.FormCreate(Sender: TObject);
begin
 //
end;

procedure TForm1.FormShow(Sender: TObject);
begin
 m_sGridParse.Cells[0,0] := 'Index';
 m_sGridParse.Cells[1,0] := 'Type';
 m_sGridParse.Cells[2,0] := 'Subtype';
 m_sGridParse.Cells[3,0] := 'Token';
 m_sGridParse.Cells[4,0] := 'Token Tree';
end;

procedure TForm1.btnParseClick(Sender: TObject);
var
 i, j, l_iTokenCount, l_iIndentCount: Integer;
 l_sStr, l_sTokTree: String;
 l_oExcelFormula: TExcelFormula;
 l_oToken: TExcelFormulaToken;
begin
 for i := 1 to (m_sGridParse.RowCount-1) do begin
   m_sGridParse.Rows[i].Clear;
 end;
 //
 l_sStr := txfExcelFormula.Text;
 l_oExcelFormula := TExcelFormula.Create(l_sStr);
 //
 l_iTokenCount := l_oExcelFormula.GetCount;
 m_sGridParse.RowCount := l_iTokenCount + 1;
 l_iIndentCount := 0;
 for i := 0 to l_iTokenCount-1 do begin
   l_oToken := l_oExcelFormula.GetToken(i);
   if l_oToken.TokSubType = TExcelFormulaTokenSubtype.enStop then begin
     if l_iIndentCount > 0 then
       Dec(l_iIndentCount);
   end;
   l_sTokTree := '|';
   for j := 1 to l_iIndentCount do begin
     l_sTokTree := l_sTokTree + ' |';
   end;
   l_sTokTree := l_sTokTree + l_oToken.TokValue;
   if l_oToken.TokSubType = TExcelFormulaTokenSubtype.enStart then begin
     Inc(l_iIndentCount);
   end;
   m_sGridParse.Cells[0,i+1] := IntToStr(i+1);
   m_sGridParse.Cells[1,i+1] := l_oToken.GetTokenTypeString;
   m_sGridParse.Cells[2,i+1] := l_oToken.GetTokenSubTypeString;
   m_sGridParse.Cells[3,i+1] := l_oToken.TokValue;
   m_sGridParse.Cells[4,i+1] := l_sTokTree;
 end;
 l_oExcelFormula.Free;
end;

end.
